import { select } from 'd3';

export const updateInfoTable = (selection, props) => {
  const {
    selectedGeneData,
    inputGeneList
  } = props;
        
  function filter_table_data(data, gene_list) {
          //console.log(gene_list)
          let data_ = data.filter(function (d) {
              return gene_list.indexOf(d.Gene_name) > -1
          })
          //console.log(data_)
          return data_
      }
  function update(data, gene){
      let filtered_data = filter_table_data(data, gene);
          let keys = ["Gene_name","DEG","level1_len","level2_len","level1_list","level2_list"]
          let trs = d3.select('tbody').selectAll('tr').data(filtered_data, d => d.Gene_name);
           trs.exit().style('font-weight', 'bolder')
                .transition().delay(600)
                .duration(800).style('opacity', '0')
                .remove();
    				let new_tds = trs.enter().append('tr')
    					.selectAll('td').data(k => keys.map(eachKey => [eachKey, k[eachKey]]), tuple => tuple[0])
            new_tds.enter().append('td').style('opacity', 0)
    					.transition().delay(200)
    					.duration(800).style('opacity', 1).text(d => d[1])
  }
  let gene_list = selectedGeneData.map(d => d.gene)
  //console.log(inputGeneList)
  let filtered_data = filter_table_data(inputGeneList, gene_list)
  update(filtered_data, gene_list)
};